'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _templateObject = _taggedTemplateLiteral(['\n    top: 0;\n    right: 0;\n    bottom: 0;\n    left: 0;\n    margin: \'auto\';\n    padding: ', ';\n'], ['\n    top: 0;\n    right: 0;\n    bottom: 0;\n    left: 0;\n    margin: \'auto\';\n    padding: ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _colorCodes = require('../colorCodes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } /**
                                                                                                                                                   * Created by abhishek.panda on 31/08/17.
                                                                                                                                                   */


var ContentWrapper = _styledComponents2.default.div(_templateObject, function (props) {
    return props.contentSpacing || '20px';
});

var Card = function Card(props) {
    var style = {
        borderRadius: props.borderRadius || '4px',
        backgroundColor: props.backgroundColor || _colorCodes.colors.whiteText,
        boxShadow: props.boxShadow || '0 -1px 3px 0 rgba(208,208,208,0.5)',
        height: props.height || 'auto',
        margin: props.margin || '0px',
        position: props.position || 'relative',
        width: props.minWidth ? 'unset' : props.width || '636px',
        minWidth: props.width ? 'unset' : props.minWidth || '222px',
        overflow: props.overflow || 'hidden',
        display: props.display || 'block',
        zIndex: props.zIndex || 'unset'
    };

    return _react2.default.createElement(
        'div',
        { style: style, className: props.className || '' },
        _react2.default.createElement(
            ContentWrapper,
            { contentSpacing: props.padding },
            props.children
        )
    );
};

exports.default = Card;


Card.propTypes = {
    borderRadius: _propTypes2.default.string,
    backgroundColor: _propTypes2.default.string,
    boxShadow: _propTypes2.default.string,
    height: _propTypes2.default.string,
    margin: _propTypes2.default.string,
    position: _propTypes2.default.string,
    width: _propTypes2.default.string,
    minWidth: _propTypes2.default.string,
    overflow: _propTypes2.default.string,
    display: _propTypes2.default.string,
    zIndex: _propTypes2.default.string
};