'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _VisibilityToggleHelper = require('../VisibilityToggleHelper');

var _VisibilityToggleHelper2 = _interopRequireDefault(_VisibilityToggleHelper);

var _EditableContainer = require('./EditableContainer');

var _EditableContainer2 = _interopRequireDefault(_EditableContainer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ContentContainer = function (_PureComponent) {
    _inherits(ContentContainer, _PureComponent);

    function ContentContainer() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, ContentContainer);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ContentContainer.__proto__ || Object.getPrototypeOf(ContentContainer)).call.apply(_ref, [this].concat(args))), _this), _this.onClose = function (state) {
            if (!state.active) {
                _this.props.onClose();
            }
        }, _this.render = function () {
            return _react2.default.createElement(
                _VisibilityToggleHelper2.default,
                {
                    clickableElem: _this.props.clickableElem,
                    action: _this.props.action,
                    position: _this.props.position,
                    onChange: _this.onClose
                },
                _react2.default.createElement(_EditableContainer2.default, {
                    validateFunction: _this.props.validateInput,
                    onSave: _this.props.onChange,
                    title: _this.props.title,
                    description: _this.props.description,
                    onCancel: _this.props.onCancel,
                    content: _this.props.content,
                    inputType: _this.props.type,
                    loading: _this.props.editState.isLoading,
                    error: _this.props.editState.isError,
                    success: _this.props.editState.isSuccess,
                    successMessage: _this.props.successMessage,
                    errorMessage: _this.props.errorMessage,
                    showConfirmationDialog: _this.props.showConfirmationDialog
                })
            );
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    return ContentContainer;
}(_react.PureComponent);

ContentContainer.propTypes = {
    position: _propTypes2.default.shape({
        horizontal: _propTypes2.default.string,
        vertical: _propTypes2.default.string
    }).isRequired,
    onCancel: _propTypes2.default.func,
    onClose: _propTypes2.default.func,
    onChange: _propTypes2.default.func.isRequired,
    content: _propTypes2.default.string.isRequired,
    type: _propTypes2.default.string.isRequired,
    title: _propTypes2.default.string,
    description: _propTypes2.default.string,
    validateInput: _propTypes2.default.func.isRequired,
    action: _propTypes2.default.string,
    showConfirmationDialog: _propTypes2.default.bool,
    successMessage: _propTypes2.default.string,
    errorMessage: _propTypes2.default.string,
    clickableElem: _propTypes2.default.node.isRequired,
    editState: _propTypes2.default.shape({
        isLoading: _propTypes2.default.bool,
        isSuccess: _propTypes2.default.bool,
        isError: _propTypes2.default.bool
    })
};

ContentContainer.defaultProps = {
    onCancel: function onCancel() {},
    onClose: function onClose() {},
    action: 'click',
    title: '',
    description: '',
    successMessage: 'Value updated successfully',
    errorMessage: 'Value updation failed!',
    showConfirmationDialog: false,
    editState: _propTypes2.default.shape({
        isLoading: false,
        isSuccess: false,
        isError: false
    })
};

exports.default = ContentContainer;