'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Duration = function Duration(_ref) {
    var label = _ref.label;
    return _react2.default.createElement(
        _react.Fragment,
        null,
        label ? _react2.default.createElement(
            _styles.DurationBlock,
            null,
            label
        ) : ''
    );
};

var EventLine = function (_Component) {
    _inherits(EventLine, _Component);

    function EventLine() {
        _classCallCheck(this, EventLine);

        return _possibleConstructorReturn(this, (EventLine.__proto__ || Object.getPrototypeOf(EventLine)).apply(this, arguments));
    }

    _createClass(EventLine, [{
        key: 'render',
        value: function render() {
            var width = this.props.width;
            var lineType = this.props.type;

            return _react2.default.createElement(
                _react.Fragment,
                null,
                lineType === 'active' ? _react2.default.createElement(
                    _styles.ActiveLine,
                    { width: width },
                    this.props.children
                ) : _react2.default.createElement(
                    _styles.InActiveLine,
                    { width: width },
                    this.props.children
                )
            );
        }
    }]);

    return EventLine;
}(_react.Component);

EventLine.Duration = Duration;


Duration.propTypes = {
    label: _propTypes2.default.string
};

EventLine.propTypes = {
    width: _propTypes2.default.number,
    type: _propTypes2.default.string,
    children: _propTypes2.default.arrayOf(_propTypes2.default.node)
};

Duration.defaultProps = {
    label: ''
};

EventLine.defaultProps = {
    width: '100',
    type: 'in-active',
    children: []
};

exports.default = EventLine;