'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CarouselContent = function (_React$Component) {
    _inherits(CarouselContent, _React$Component);

    function CarouselContent(props) {
        _classCallCheck(this, CarouselContent);

        var _this = _possibleConstructorReturn(this, (CarouselContent.__proto__ || Object.getPrototypeOf(CarouselContent)).call(this, props));

        _this.state = {
            totalWidth: 0,
            itemWidth: parseInt(_this.props.width.replace('px', ''), 10)
        };
        _this.setCarouselFullWidth = _this.setCarouselFullWidth.bind(_this);
        return _this;
    }

    _createClass(CarouselContent, [{
        key: 'setCarouselFullWidth',
        value: function setCarouselFullWidth() {
            var _this2 = this;

            this.setState(function (prevState) {
                return {
                    totalWidth: prevState.totalWidth + _this2.state.itemWidth
                };
            });
            this.props.initializeSlider(this.state.itemWidth);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var items = _react2.default.Children.map(this.props.children, function (child) {
                return _react2.default.cloneElement(child, {
                    setCarouselFullWidth: _this3.setCarouselFullWidth,
                    itemWidth: _this3.state.itemWidth
                });
            });

            return _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                    'div',
                    {
                        style: {
                            width: this.state.itemWidth + 'px',
                            overflow: 'hidden',
                            margin: '0 auto'
                        }
                    },
                    _react2.default.createElement(
                        _styles.Ul,
                        {
                            left: this.props.left + 'px',
                            width: this.state.totalWidth + 'px'
                        },
                        items
                    )
                )
            );
        }
    }]);

    return CarouselContent;
}(_react2.default.Component);

exports.default = CarouselContent;


CarouselContent.propTypes = {
    width: _propTypes2.default.string.isRequired,
    initializeSlider: _propTypes2.default.func,
    children: _propTypes2.default.arrayOf(_propTypes2.default.node).isRequired,
    left: _propTypes2.default.number
};

CarouselContent.defaultProps = {
    left: 0,
    initializeSlider: function initializeSlider(f) {
        return f;
    }
};