'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Image = function (_React$Component) {
    _inherits(Image, _React$Component);

    function Image(props) {
        _classCallCheck(this, Image);

        var _this = _possibleConstructorReturn(this, (Image.__proto__ || Object.getPrototypeOf(Image)).call(this, props));

        _this.state = {
            success: true
        };
        _this.onLoad = _this.onLoad.bind(_this);
        _this.onError = _this.onError.bind(_this);
        return _this;
    }

    _createClass(Image, [{
        key: 'onLoad',
        value: function onLoad() {
            this.props.setCarouselFullWidth();
        }
    }, {
        key: 'onError',
        value: function onError() {
            console.warn('Unable to load ' + this.props.src);
            this.setState({ success: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var list = '';
            if (this.state.success) {
                list = _react2.default.createElement(
                    _styles.List,
                    { width: this.props.itemWidth + 'px' },
                    _react2.default.createElement(
                        _styles.Wrapper,
                        { dimension: this.props.itemWidth + 'px' },
                        _react2.default.createElement(_styles.Img, {
                            onLoad: this.onLoad,
                            src: this.props.src,
                            onError: this.onError
                        })
                    )
                );
            } else {
                list = null;
            }

            return list;
        }
    }]);

    return Image;
}(_react2.default.Component);

exports.default = Image;


Image.propTypes = {
    setCarouselFullWidth: _propTypes2.default.func,
    itemWidth: _propTypes2.default.number,
    src: _propTypes2.default.string.isRequired
};

Image.defaultProps = {
    setCarouselFullWidth: function setCarouselFullWidth(f) {
        return f;
    },
    itemWidth: 0
};