'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PrimaryNavTab = function (_Component) {
    _inherits(PrimaryNavTab, _Component);

    function PrimaryNavTab() {
        _classCallCheck(this, PrimaryNavTab);

        return _possibleConstructorReturn(this, (PrimaryNavTab.__proto__ || Object.getPrototypeOf(PrimaryNavTab)).apply(this, arguments));
    }

    _createClass(PrimaryNavTab, [{
        key: 'render',
        value: function render() {
            var tabId = this.props.tabId;
            var link = this.props.link;
            var tabClickCallback = this.props.tabClickCallback;
            var isActive = this.props.isActive;
            var isNextToActiveTab = this.props.isNextToActiveTab;

            if (isActive) {
                return _react2.default.createElement(
                    _styles.ActivePrimaryNavTabDiv,
                    null,
                    this.props.children
                );
            } else if (link) {
                return _react2.default.createElement(
                    _styles.InactivePrimaryNavTabLink,
                    {
                        href: link,
                        onClick: function onClick(e) {
                            return tabClickCallback(tabId, e);
                        },
                        isNextToActiveTab: isNextToActiveTab
                    },
                    this.props.children
                );
            }

            return _react2.default.createElement(
                _styles.InactivePrimaryNavTabDiv,
                {
                    onClick: function onClick(e) {
                        return tabClickCallback(tabId, e);
                    },
                    isNextToActiveTab: isNextToActiveTab
                },
                this.props.children
            );
        }
    }]);

    return PrimaryNavTab;
}(_react.Component);

PrimaryNavTab.propTypes = {
    tabId: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]).isRequired,
    link: _propTypes2.default.string,
    tabClickCallback: _propTypes2.default.func,
    isActive: _propTypes2.default.bool,
    isNextToActiveTab: _propTypes2.default.bool,
    children: _propTypes2.default.arrayOf(_propTypes2.default.node).isRequired
};

PrimaryNavTab.defaultProps = {
    link: undefined,
    tabClickCallback: undefined,
    isActive: false,
    isNextToActiveTab: false
};

exports.default = PrimaryNavTab;