'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _PrimaryTab = require('../PrimaryTab');

var _PrimaryTab2 = _interopRequireDefault(_PrimaryTab);

var _SecondaryTab = require('../SecondaryTab');

var _SecondaryTab2 = _interopRequireDefault(_SecondaryTab);

var _TertiaryTab = require('../TertiaryTab');

var _TertiaryTab2 = _interopRequireDefault(_TertiaryTab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TabEnhancer = function (_Component) {
    _inherits(TabEnhancer, _Component);

    function TabEnhancer() {
        _classCallCheck(this, TabEnhancer);

        return _possibleConstructorReturn(this, (TabEnhancer.__proto__ || Object.getPrototypeOf(TabEnhancer)).apply(this, arguments));
    }

    _createClass(TabEnhancer, [{
        key: 'processChildren',
        value: function processChildren() {
            var _this2 = this;

            var isActive = false;
            var isNextToActiveTab = false;

            return _react2.default.Children.map(this.props.children, function (child) {
                if (child) {
                    isActive = child.props.tabId === _this2.props.activeId;

                    var clonedElement = _react2.default.cloneElement(child, {
                        isActive: isActive,
                        isNextToActiveTab: isNextToActiveTab,
                        tabClickCallback: _this2.props.tabClickCallback
                    });

                    if (isActive) {
                        isNextToActiveTab = true;
                        isActive = false;
                    } else {
                        isNextToActiveTab = false;
                    }

                    return clonedElement;
                }

                return child;
            });
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _react2.default.Fragment,
                null,
                this.processChildren()
            );
        }
    }]);

    return TabEnhancer;
}(_react.Component);

TabEnhancer.propTypes = {
    activeId: _propTypes2.default.string,
    children: _propTypes2.default.arrayOf(_propTypes2.default.node),
    tabClickCallback: _propTypes2.default.func
};

TabEnhancer.defaultProps = {
    activeId: false,
    children: undefined,
    tabClickCallback: undefined
};

exports.default = TabEnhancer;