'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TertiaryNavTab = function (_Component) {
    _inherits(TertiaryNavTab, _Component);

    function TertiaryNavTab() {
        _classCallCheck(this, TertiaryNavTab);

        return _possibleConstructorReturn(this, (TertiaryNavTab.__proto__ || Object.getPrototypeOf(TertiaryNavTab)).apply(this, arguments));
    }

    _createClass(TertiaryNavTab, [{
        key: 'render',
        value: function render() {
            var tabId = this.props.tabId;
            var link = this.props.link;
            var label = this.props.label;
            var tabClickCallback = this.props.tabClickCallback;
            var isActive = this.props.isActive;

            var tabLabelContent = _react2.default.createElement(
                'div',
                { className: 'label' },
                label
            );
            var contentContainerBorderHider = _react2.default.createElement('div', { className: 'border-hider' });
            var tabElement = null;

            if (isActive) {
                tabElement = _react2.default.createElement(
                    _styles.ActiveTertiaryNavTabDiv,
                    null,
                    tabLabelContent,
                    contentContainerBorderHider
                );
            } else if (link) {
                tabElement = _react2.default.createElement(
                    _styles.InactiveTertiaryNavTabLink,
                    {
                        href: link,
                        onClick: function onClick(e) {
                            return tabClickCallback(tabId, e);
                        }
                    },
                    tabLabelContent
                );
            } else {
                tabElement = _react2.default.createElement(
                    _styles.InactiveTertiaryNavTabDiv,
                    {
                        onClick: function onClick(e) {
                            return tabClickCallback(tabId, e);
                        }
                    },
                    tabLabelContent
                );
            }

            return tabElement;
        }
    }]);

    return TertiaryNavTab;
}(_react.Component);

TertiaryNavTab.propTypes = {
    tabId: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]).isRequired,
    link: _propTypes2.default.string,
    label: _propTypes2.default.string.isRequired,
    tabClickCallback: _propTypes2.default.func,
    isActive: _propTypes2.default.bool
};

TertiaryNavTab.defaultProps = {
    link: undefined,
    tabClickCallback: undefined,
    isActive: false
};

exports.default = TertiaryNavTab;