'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.NavigationTabNPanel = exports.PanelGroup = exports.Panel = exports.TabEnhancer = exports.TabGroup = exports.TertiaryTab = exports.SecondaryTab = exports.PrimaryTab = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _PrimaryTab = require('./components/PrimaryTab');

var _PrimaryTab2 = _interopRequireDefault(_PrimaryTab);

var _SecondaryTab = require('./components/SecondaryTab');

var _SecondaryTab2 = _interopRequireDefault(_SecondaryTab);

var _TertiaryTab = require('./components/TertiaryTab');

var _TertiaryTab2 = _interopRequireDefault(_TertiaryTab);

var _TabGroup = require('./components/TabGroup');

var _TabGroup2 = _interopRequireDefault(_TabGroup);

var _Panel = require('./components/Panel');

var _Panel2 = _interopRequireDefault(_Panel);

var _PanelGroup = require('./components/PanelGroup');

var _PanelGroup2 = _interopRequireDefault(_PanelGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NavigationTabNPanel = function (_Component) {
    _inherits(NavigationTabNPanel, _Component);

    function NavigationTabNPanel(props) {
        _classCallCheck(this, NavigationTabNPanel);

        var _this = _possibleConstructorReturn(this, (NavigationTabNPanel.__proto__ || Object.getPrototypeOf(NavigationTabNPanel)).call(this, props));

        _this.state = {
            activeContentId: _this.props.activeContentId
        };
        _this.tabClickCallback = _this.tabClickCallback.bind(_this);
        return _this;
    }

    _createClass(NavigationTabNPanel, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.props.activeContentId !== nextProps.activeContentId) {
                this.setState({ activeContentId: nextProps.activeContentId });
            }
        }
    }, {
        key: 'processChildren',
        value: function processChildren() {
            var _this2 = this;

            return _react2.default.Children.map(this.props.children, function (child) {
                if (child.type === _TabGroup2.default || child.type === _TabGroup.TabEnhancer) {
                    return _react2.default.cloneElement(child, {
                        activeId: _this2.state.activeContentId,
                        tabClickCallback: _this2.tabClickCallback
                    });
                } else if (child.type === _PanelGroup2.default) {
                    return _react2.default.cloneElement(child, {
                        activeId: _this2.state.activeContentId
                    });
                }
                return child;
            });
        }
    }, {
        key: 'tabClickCallback',
        value: function tabClickCallback(tabId, e) {
            this.setState({
                activeContentId: tabId
            });
            this.props.onClickTabHandler(tabId, e);
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _react2.default.Fragment,
                null,
                this.processChildren()
            );
        }
    }]);

    return NavigationTabNPanel;
}(_react.Component);

NavigationTabNPanel.propTypes = {
    activeContentId: _propTypes2.default.string.isRequired,
    onClickTabHandler: _propTypes2.default.func,
    children: _propTypes2.default.arrayOf(_propTypes2.default.node)
};

NavigationTabNPanel.defaultProps = {
    onClickTabHandler: function onClickTabHandler() {},
    children: undefined
};

exports.PrimaryTab = _PrimaryTab2.default;
exports.SecondaryTab = _SecondaryTab2.default;
exports.TertiaryTab = _TertiaryTab2.default;
exports.TabGroup = _TabGroup2.default;
exports.TabEnhancer = _TabGroup.TabEnhancer;
exports.Panel = _Panel2.default;
exports.PanelGroup = _PanelGroup2.default;
exports.NavigationTabNPanel = NavigationTabNPanel;