'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _SelectSmall = require('../../FormElements/Select/SelectSmall');

var _SelectSmall2 = _interopRequireDefault(_SelectSmall);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PageSizeSelector = function (_Component) {
    _inherits(PageSizeSelector, _Component);

    function PageSizeSelector() {
        _classCallCheck(this, PageSizeSelector);

        return _possibleConstructorReturn(this, (PageSizeSelector.__proto__ || Object.getPrototypeOf(PageSizeSelector)).apply(this, arguments));
    }

    _createClass(PageSizeSelector, [{
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _styles.PageSizeSelectorContainer,
                null,
                _react2.default.createElement(_styles.RoundSeparator, null),
                _react2.default.createElement(
                    _SelectSmall2.default,
                    {
                        onChange: this.props.onPageSizeChange,
                        value: this.props.pageSize
                    },
                    this.props.pageSizeOptions.map(function (pageSize) {
                        return _react2.default.createElement(
                            'option',
                            { key: pageSize, value: pageSize },
                            pageSize
                        );
                    })
                ),
                _react2.default.createElement(
                    _styles.PaginatorText,
                    null,
                    'Items per page'
                ),
                _react2.default.createElement(_styles.LineSeparator, null),
                _react2.default.createElement(
                    _styles.PaginatorText,
                    null,
                    this.props.startItem,
                    '-',
                    this.props.endItem,
                    ' of',
                    ' ',
                    this.props.totalItems,
                    ' items'
                ),
                _react2.default.createElement(_styles.RoundSeparator, null)
            );
        }
    }]);

    return PageSizeSelector;
}(_react.Component);

PageSizeSelector.propTypes = {
    pageSize: _propTypes2.default.number,
    startItem: _propTypes2.default.number,
    endItem: _propTypes2.default.number,
    totalItems: _propTypes2.default.number,
    pageSizeOptions: _propTypes2.default.arrayOf(_propTypes2.default.number),
    onPageSizeChange: _propTypes2.default.func
};

PageSizeSelector.defaultProps = {
    pageSize: 10,
    startItem: 0,
    endItem: 0,
    totalItems: 0,
    pageSizeOptions: [10, 25, 50, 100],
    onPageSizeChange: function onPageSizeChange() {}
};

exports.default = PageSizeSelector;