'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _polished = require('polished');

var _colorCodes = require('../colorCodes');

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var calculateCompletedPercentage = function calculateCompletedPercentage(currentCount, totalCount) {
    return parseInt(currentCount * 100) / parseInt(totalCount) + '%';
};

var ProgressBar = function ProgressBar(_ref) {
    var height = _ref.height,
        children = _ref.children,
        progressBarColor = _ref.progressBarColor,
        currentCount = _ref.currentCount,
        totalCount = _ref.totalCount;

    var completedPercent = calculateCompletedPercentage(currentCount, totalCount);
    return _react2.default.createElement(
        _styles.ProgressBarContainer,
        { height: height },
        _react2.default.createElement(_styles.CompletedProgress, {
            width: completedPercent,
            height: height,
            progressBarColor: progressBarColor
        }),
        _react2.default.createElement(
            _styles.ChildrenContainer,
            null,
            children
        )
    );
};

ProgressBar.propTypes = {
    currentCount: _propTypes2.default.number.isRequired,
    totalCount: _propTypes2.default.number.isRequired,
    children: _propTypes2.default.node,
    height: _propTypes2.default.number,
    progressBarColor: _propTypes2.default.string
};

ProgressBar.defaultProps = {
    children: undefined,
    height: 30,
    progressBarColor: (0, _polished.rgba)(_colorCodes.guidelineColors.states.success, _colorCodes.lightenColors.lighter)
};

exports.default = ProgressBar;