'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactSelect = require('react-select');

var _reactSelect2 = _interopRequireDefault(_reactSelect);

require('react-select/dist/react-select.css');

var _SelectFilter = require('./styles/SelectFilter');

var _SelectOption = require('./SelectOption');

var _SelectOption2 = _interopRequireDefault(_SelectOption);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by manoraj.k on 17/08/17.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var SelectFilter = function (_React$Component) {
    _inherits(SelectFilter, _React$Component);

    _createClass(SelectFilter, null, [{
        key: 'arrowRenderer',
        value: function arrowRenderer(_ref) {
            var isOpen = _ref.isOpen;

            if (isOpen) {
                return _react2.default.createElement('i', { className: 'fa fa-chevron-up inprogress-icon-color' });
            }
            return _react2.default.createElement('i', { className: 'fa fa-chevron-down inprogress-icon-color' });
        }
    }, {
        key: 'valueRenderer',
        value: function valueRenderer(_ref2) {
            var label = _ref2.label;

            return _react2.default.createElement(
                'span',
                { className: 'selected-text' },
                label
            );
        }
    }]);

    function SelectFilter(props) {
        _classCallCheck(this, SelectFilter);

        var _this = _possibleConstructorReturn(this, (SelectFilter.__proto__ || Object.getPrototypeOf(SelectFilter)).call(this, props));

        _this.onChange = _this.onChange.bind(_this);
        return _this;
    }

    _createClass(SelectFilter, [{
        key: 'onChange',
        value: function onChange(value) {
            if (this.props.onChange) {
                this.props.onChange(value);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                width = _props.width,
                height = _props.height,
                simpleValue = _props.simpleValue,
                placeholder = _props.placeholder,
                arrowRenderer = _props.arrowRenderer,
                name = _props.name,
                searchable = _props.searchable,
                clearable = _props.clearable,
                options = _props.options,
                valueRenderer = _props.valueRenderer,
                value = _props.value,
                optionComponent = _props.optionComponent;

            return _react2.default.createElement(
                _SelectFilter.SelectFilterContainer,
                { width: width, height: height },
                _react2.default.createElement(_reactSelect2.default, {
                    simpleValue: simpleValue,
                    name: name,
                    placeholder: placeholder,
                    arrowRenderer: arrowRenderer || SelectFilter.arrowRenderer,
                    searchable: searchable,
                    clearable: clearable,
                    options: options,
                    onChange: this.onChange,
                    valueRenderer: valueRenderer || SelectFilter.valueRenderer,
                    value: value,
                    optionComponent: optionComponent || _SelectOption2.default
                })
            );
        }
    }]);

    return SelectFilter;
}(_react2.default.Component);

exports.default = SelectFilter;


SelectFilter.propTypes = {
    onChange: _propTypes2.default.func,
    width: _propTypes2.default.string,
    height: _propTypes2.default.string,
    simpleValue: _propTypes2.default.bool.isRequired,
    placeholder: _propTypes2.default.string.isRequired,
    arrowRenderer: _propTypes2.default.func,
    name: _propTypes2.default.string.isRequired,
    searchable: _propTypes2.default.bool.isRequired,
    clearable: _propTypes2.default.bool.isRequired,
    options: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        name: _propTypes2.default.string,
        label: _propTypes2.default.string,
        clearableValue: _propTypes2.default.bool
    })).isRequired,
    valueRenderer: _propTypes2.default.func,
    value: _propTypes2.default.string,
    optionComponent: _propTypes2.default.func
};

SelectFilter.defaultProps = {
    onChange: function onChange(f) {
        return f;
    },
    width: '220px',
    height: '20px',
    arrowRenderer: SelectFilter.arrowRenderer,
    valueRenderer: SelectFilter.valueRenderer,
    value: '',
    optionComponent: _SelectOption2.default
};