'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactClickOutside = require('react-click-outside');

var _reactClickOutside2 = _interopRequireDefault(_reactClickOutside);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ActionMenu = function (_Component) {
    _inherits(ActionMenu, _Component);

    function ActionMenu(props) {
        _classCallCheck(this, ActionMenu);

        var _this = _possibleConstructorReturn(this, (ActionMenu.__proto__ || Object.getPrototypeOf(ActionMenu)).call(this, props));

        _this.onListItemSelect = function (value, e) {
            _this.setState({
                value: value
            });
            _this.props.onChange(value, e);
        };

        _this.state = {
            value: _this.props.value
        };
        return _this;
    }

    _createClass(ActionMenu, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            this.setState({
                value: nextProps.value
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                _styles.List,
                null,
                this.props.listData.map(function (datum) {
                    if (_this2.state.value === datum.value && _this2.props.isSelectionStored) {
                        return _react2.default.createElement(
                            _styles.ActiveListItem,
                            { key: datum.value },
                            datum.label
                        );
                    }

                    return _react2.default.createElement(
                        _styles.ListItem,
                        {
                            key: datum.value,
                            onClick: function onClick(e) {
                                return _this2.onListItemSelect(datum.value, e);
                            }
                        },
                        datum.label
                    );
                })
            );
        }
    }]);

    return ActionMenu;
}(_react.Component);

ActionMenu.propTypes = {
    value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    isSelectionStored: _propTypes2.default.bool,
    listData: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
        label: _propTypes2.default.string
    })).isRequired,
    onChange: _propTypes2.default.func
};

ActionMenu.defaultProps = {
    value: '',
    isSelectionStored: false,
    onChange: function onChange() {}
};

exports.default = (0, _reactClickOutside2.default)(ActionMenu);