'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ = require('..');

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SliderFilter = function (_React$Component) {
    _inherits(SliderFilter, _React$Component);

    _createClass(SliderFilter, null, [{
        key: 'decodeValue',
        value: function decodeValue(value, startKey, endKey) {
            if (!Array.isArray(value)) {
                return [value[startKey], value[endKey]];
            }

            return value;
        }
    }, {
        key: 'encodeValue',
        value: function encodeValue(value, startKey, endKey) {
            if (value.length && startKey && endKey) {
                var _ref;

                return _ref = {}, _defineProperty(_ref, startKey, value[0]), _defineProperty(_ref, endKey, value[1]), _ref;
            }

            return value;
        }
    }]);

    function SliderFilter(props) {
        _classCallCheck(this, SliderFilter);

        var _this = _possibleConstructorReturn(this, (SliderFilter.__proto__ || Object.getPrototypeOf(SliderFilter)).call(this, props));

        _this.onSliderChange = function (value) {
            _this.setState({ value: value });
        };

        _this.resetFilter = function (e) {
            _this.setState({ value: [] });
            e.stopPropagation();
        };

        _this.state = {
            value: SliderFilter.decodeValue(props.value, props.valueStartKey, props.valueEndKey)
        };
        return _this;
    }

    _createClass(SliderFilter, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.value && !(0, _isEqual2.default)(this.state.value, nextProps.value)) {
                this.setState({
                    value: SliderFilter.decodeValue(nextProps.value, nextProps.valueStartKey, nextProps.valueEndKey)
                });
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (this.state.value[0] !== prevState.value[0] || this.state.value[1] !== prevState.value[1]) {
                if (this.props.onChange) {
                    this.props.onChange(SliderFilter.encodeValue(this.state.value, this.props.valueStartKey, this.props.valueEndKey), this.props.name);
                }
            }
        }
    }, {
        key: 'getCustomSelectLabelTemplate',
        value: function getCustomSelectLabelTemplate() {
            if (this.state.value.length) {
                return _react2.default.createElement(
                    _styles.ChipLabelContainer,
                    null,
                    _react2.default.createElement(
                        _.Chip,
                        { onRemoveClick: this.resetFilter },
                        this.props.chipLabel,
                        this.state.value[0],
                        ' - ',
                        this.state.value[1]
                    )
                );
            }

            return _react2.default.createElement(
                _styles.TextLabelContainer,
                null,
                this.props.label
            );
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _.CustomSelect,
                {
                    name: this.props.name,
                    isActive: this.props.isActive,
                    labelContent: this.getCustomSelectLabelTemplate()
                },
                _react2.default.createElement(
                    _styles.CustomSelectBodyContent,
                    null,
                    _react2.default.createElement(_.Slider, _extends({}, this.props, {
                        value: this.state.value,
                        onChange: this.onSliderChange
                    }))
                )
            );
        }
    }]);

    return SliderFilter;
}(_react2.default.Component);

SliderFilter.propTypes = {
    name: _propTypes2.default.string,
    label: _propTypes2.default.string.isRequired,
    chipLabel: _propTypes2.default.string.isRequired,
    min: _propTypes2.default.number.isRequired,
    max: _propTypes2.default.number.isRequired,
    value: _propTypes2.default.oneOf([_propTypes2.default.arrayOf(_propTypes2.default.number), _propTypes2.default.object]),
    valueStartKey: _propTypes2.default.string,
    isActive: _propTypes2.default.bool,
    valueEndKey: _propTypes2.default.string,
    onChange: _propTypes2.default.func
};

SliderFilter.defaultProps = {
    name: '',
    value: [],
    valueStartKey: '',
    valueEndKey: '',
    isActive: false,
    onChange: function onChange() {}
};

exports.default = SliderFilter;