'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _polished = require('polished');

var _colorCodes = require('../colorCodes');

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TreeElement = function (_React$Component) {
    _inherits(TreeElement, _React$Component);

    function TreeElement(props) {
        _classCallCheck(this, TreeElement);

        var _this = _possibleConstructorReturn(this, (TreeElement.__proto__ || Object.getPrototypeOf(TreeElement)).call(this, props));

        _this.onClickHandler = _this.onClickHandler.bind(_this);
        return _this;
    }

    _createClass(TreeElement, [{
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps) {
            if (this.props.active && this.props.active !== prevProps.active) {
                this.props.setActiveTab(this.props.name, this.props.level);
            }
        }
    }, {
        key: 'onClickHandler',
        value: function onClickHandler() {
            this.props.onSelect(this.props.name);
            this.props.setActiveTab(this.props.name, this.props.level);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                _styles.Li,
                {
                    onClick: function onClick() {
                        return _this2.onClickHandler();
                    },
                    style: {
                        backgroundColor: this.props.isActive ? (0, _polished.rgba)(_colorCodes.guidelineColors.accent.primary, _colorCodes.lightenColors.lightest) : _colorCodes.guidelineColors.white
                    }
                },
                this.props.children
            );
        }
    }]);

    return TreeElement;
}(_react2.default.Component);

exports.default = TreeElement;


TreeElement.propTypes = {
    children: _propTypes2.default.node.isRequired,
    setActiveTab: _propTypes2.default.func.isRequired,
    onSelect: _propTypes2.default.func.isRequired,
    isActive: _propTypes2.default.bool.isRequired,
    active: _propTypes2.default.bool.isRequired,
    level: _propTypes2.default.number.isRequired,
    name: _propTypes2.default.string.isRequired
};