'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Card = require('../Card');

var _Card2 = _interopRequireDefault(_Card);

var _styles = require('./styles');

var _Layout = require('../Layout');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TreePanel = function (_React$Component) {
    _inherits(TreePanel, _React$Component);

    function TreePanel(props) {
        _classCallCheck(this, TreePanel);

        var _this = _possibleConstructorReturn(this, (TreePanel.__proto__ || Object.getPrototypeOf(TreePanel)).call(this, props));

        _this.state = {
            activeTab: ''
        };
        _this.setActiveTab = _this.setActiveTab.bind(_this);
        _this.clearActiveTab = _this.clearActiveTab.bind(_this);
        return _this;
    }

    _createClass(TreePanel, [{
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            if (this.props.level > this.props.currentLevel) {
                if (this.state.activeTab) {
                    this.clearActiveTab();
                }
            }
        }
    }, {
        key: 'setActiveTab',
        value: function setActiveTab(tab, level) {
            this.setState({
                activeTab: tab
            });
            this.props.setCurrentLevel(level);
        }
    }, {
        key: 'clearActiveTab',
        value: function clearActiveTab() {
            this.setState({
                activeTab: ''
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var items = _react2.default.Children.map(this.props.children, function (child) {
                return _react2.default.cloneElement(child, {
                    setActiveTab: _this2.setActiveTab,
                    isActive: _this2.state.activeTab === child.props.name || child.props.active,
                    level: _this2.props.level
                });
            });

            var pointer = null;

            if (this.props.pointer === 'true') {
                pointer = _react2.default.createElement(_styles.Pointer, null);
            }

            return _react2.default.createElement(
                _Layout.FlexCell,
                {
                    flex: 0,
                    style: {
                        margin: '0px 10px 0px 0px',
                        flex: 0,
                        position: 'relative',
                        display: this.props.children.length ? 'block' : 'none',
                        width: this.props.width
                    }
                },
                _react2.default.createElement(
                    _Card2.default,
                    { width: this.props.width || '100%', padding: '0px' },
                    _react2.default.createElement(
                        _styles.Ul,
                        { height: this.props.height },
                        items
                    )
                ),
                pointer
            );
        }
    }]);

    return TreePanel;
}(_react2.default.Component);

exports.default = TreePanel;


TreePanel.propTypes = {
    children: _propTypes2.default.node.isRequired,
    setCurrentLevel: _propTypes2.default.func.isRequired,
    currentLevel: _propTypes2.default.number.isRequired,
    level: _propTypes2.default.number.isRequired,
    pointer: _propTypes2.default.string.isRequired,
    width: _propTypes2.default.string.isRequired,
    height: _propTypes2.default.string.isRequired
};